unit mainform;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, FileUtil, ZDataset, ZConnection, ZCompatibility,
  VpBaseDS, VpPrtFmtCBox, VpDayView, VpWeekView, VpFlxDS, VpContactGrid, Forms,
  Controls, Graphics, Dialogs;

type

  { TForm1 }

  TForm1 = class(TForm)
    DSRec: TDataSource;
    DSRes: TDataSource;
    DSCont: TDataSource;
    DSEvent: TDataSource;
    DSTask: TDataSource;
    VpContactGrid1: TVpContactGrid;
    VpCLink: TVpControlLink;
    VpDayView1: TVpDayView;
    VpDataStore: TVpFlexDataStore;
    VpPrintFormatComboBox1: TVpPrintFormatComboBox;
    VpResourceCombo1: TVpResourceCombo;
    VpWeekView1: TVpWeekView;
    ZCon: TZConnection;
  //  ZCon: TZConnection;
    ZTRes: TZTable;
    ZTEvent: TZTable;
    ZTCont: TZTable;
    ZTTask: TZTable;
    ZTRecord: TZTable;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  //  ZCon:TZConnection;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var DBParams:TStringList;
    DbPath,fName :String;
begin
 //  ZCon.ClientCodepage := 'UTF-8';
 //   ZCon.ControlsCodePage := TZControlsCodePage.cCP_UTF8;
 //   ZCon.LoginPrompt := False;
 //   ZCon.Protocol := 'sqlite-3';
 //   ZCon.HostName := '';
end;

procedure TForm1.FormShow(Sender: TObject);
var DBParams:TStringList;
    DbPath,fName :String;
begin
   try
       DbPath :=GetCurrentDir+'\datas' ;
       if not DirectoryExists(DbPath) then
         If Not CreateDir ('datas') Then
           ShowMessage('Failed to create directory !');
   //    ZCon.Database:='';
       fName := ExtractFilePath(ParamStr(0)) +'datas\maintance.db3';
       if not FileExists(fName) then
        begin
         ZCon.Database:=fName;
         ZCon.Protocol:='sqlite-3';
         ZCon.Connected:=true;
         ZCon.ExecuteDirect('create Table CONTACTS ('+
            'RECORDID INTEGER not null PRIMARY KEY AUTOINCREMENT,'+
            'RESOURCEID INTEGER,'+
            'FIRSTNAME VARCHAR(50) ,'+
            'LASTNAME VARCHAR(50) , '+
            'BIRTHDATE DATE, '+
            'ANNIVERSARY DATE,'+
            'TITLE VARCHAR(50) ,'+
            'COMPANY VARCHAR(50) ,'+
            'MYPOSITION VARCHAR(30),'+
            'EMAIL VARCHAR(50) ,'+
            'ADRESS VARCHAR(50) ,'+
            'CITY VARCHAR(50) , '+
            'STATE VARCHAR(50) ,'+
            'ZIP VARCHAR(50) , '+
            'COUNTRY VARCHAR(50) ,'+
            'NOTE VARCHAR(50) , '+
            'PHONE1 VARCHAR(50) ,'+
            'PHONE2 VARCHAR(50) ,'+
            'PHONE3 VARCHAR(50) ,'+
            'PHONE4 VARCHAR(50) ,'+
            'PHONE5 VARCHAR(50) , '+
            'PHONETYPE1 VARCHAR(50) ,'+
            'PHONETYPE2 VARCHAR(50) ,'+
            'PHONETYPE3 VARCHAR(50) , '+
            'PHONETYPE4 VARCHAR(50) , '+
            'PHONETYPE5 VARCHAR(50) , '+
            'CATEGORY VARCHAR(50) ,  '+
            'CUSTOM1 VARCHAR(50) , '+
            'CUSTOM2 VARCHAR(50) ,'+
            'CUSTOM3 VARCHAR(50) , '+
            'CUSTOM4 VARCHAR(50) , '+
            'USERFIELD0 VARCHAR(50) ,'+
            'USERFIELD1 VARCHAR(50) ,'+
            'USERFIELD2 VARCHAR(50) ,'+
            'USERFIELD3 VARCHAR(50) ,'+
            'USERFIELD4 VARCHAR(50) ,'+
            'USERFIELD5 VARCHAR(50) ,'+
            'USERFIELD6 VARCHAR(50) ,'+
            'USERFIELD7 VARCHAR(50) ,'+
            'USERFIELD8 VARCHAR(50) ,'+
            'USERFIELD9 VARCHAR(50))');

         ZCon.ExecuteDirect('create table EVENTS ('+
             'RECORDID  INTEGER not null PRIMARY KEY AUTOINCREMENT,'+
             'STARTTIME TIMESTAMP,'+
             'ENDTIME TIMESTAMP, '+
             'RESOURCEID INTEGER,'+
             'DESCRIPTION VARCHAR(500) ,'+
             'NOTE VARCHAR(500) ,'+
             'CATEGORY VARCHAR(50) ,'+
             'ALLDAYEVENT VARCHAR(50) ,'+
             'ALARMWAVPATH VARCHAR(50) ,'+
             'ALARMSET VARCHAR(50) ,'+
             'ALARMADV INTEGER ,'+
             'ALARMADVTYPE INTEGER ,'+
             'SNOOZETIME VARCHAR(50) ,'+
             'REPEATCODE VARCHAR(50) ,'+
             'REPEATRANGEEND VARCHAR(50) ,'+
             'CUSTINTERVAL INTEGER ,'+
             'USERFIELD0 VARCHAR(50) ,'+
             'USERFIELD1 VARCHAR(50) ,'+
             'USERFIELD2 VARCHAR(50) ,'+
             'USERFIELD3 VARCHAR(50) ,'+
             'USERFIELD4 VARCHAR(50) ,'+
             'USERFIELD5 VARCHAR(50) ,'+
             'USERFIELD6 VARCHAR(50) ,'+
             'USERFIELD7 VARCHAR(50) ,'+
             'USERFIELD8 VARCHAR(50) ,'+
             'USERFIELD9 VARCHAR(50))');

         ZCon.ExecuteDirect('create table RESOURCES ( '+
              'RESOURCEID INTEGER not null PRIMARY KEY AUTOINCREMENT,'+
              'DESCRIPTION VARCHAR(500) ,'+
              'NOTES VARCHAR(50) , '+
              'IMAGEINDEX INTEGER,'+
              'ACTIVE VARCHAR(50) ,'+
              'USERFIELD0 VARCHAR(50) ,'+
              'USERFIELD1 VARCHAR(50) ,'+
              'USERFIELD2 VARCHAR(50) ,'+
              'USERFIELD3 VARCHAR(50) ,'+
              'USERFIELD4 VARCHAR(50) ,'+
              'USERFIELD5 VARCHAR(50) ,'+
              'USERFIELD6 VARCHAR(50) ,'+
              'USERFIELD7 VARCHAR(50) ,'+
              'USERFIELD8 VARCHAR(50) ,'+
              'USERFIELD9 VARCHAR(50))');

         ZCon.ExecuteDirect('create table TASKS ('+
               'RECORDID INTEGER not null PRIMARY KEY AUTOINCREMENT,'+
               'RESOURCEID INTEGER,'+
               'COMPLETE TIMESTAMP ,'+
               'DESCRIPTION VARCHAR(500) ,'+
               'DETAILS VARCHAR(50) ,'+
               'CREATEDON TIMESTAMP ,'+
               'COMPLETEDON TIMESTAMP ,'+
               'PRIORITY VARCHAR(50) ,'+
               'CATEGORY VARCHAR(50) ,'+
               'DUEDATE TIMESTAMP ,'+
               'USERFIELD0 VARCHAR(50) ,'+
               'USERFIELD1 VARCHAR(50) ,'+
               'USERFIELD2 VARCHAR(50) ,'+
               'USERFIELD3 VARCHAR(50) ,'+
               'USERFIELD4 VARCHAR(50) ,'+
               'USERFIELD5 VARCHAR(50) ,'+
               'USERFIELD6 VARCHAR(50) ,'+
               'USERFIELD7 VARCHAR(50) ,'+
               'USERFIELD8 VARCHAR(50) ,'+
               'USERFIELD9 VARCHAR(50)) ');

          ZCon.ExecuteDirect('create table Record( resourceid integer not null, EventId integer not null, TaskId integer not null, ContactId Integer not null, UserField varchar(20) not null )');
 //         ZCon.Commit;
//          ZCon.Connected:=false;
//          ZCon.Database:=fname;
//          ZCon.Connect;
         ZTRecord.Active:=true;
        end
       else
        begin
         fName := ExtractFilePath(ParamStr(0)) +'datas\maintance.db3';
         ZCon.Database:=fname;

         If ZCon.Connected = false then begin
            ZCon.Connected:=true;
         end;

     end;
//        ZCon.Connected:=true;
        VpDataStore.Connected:=true;
   except
       showmessage('Conect to Db was not sucesfull');
     end;

 end;

end.

